"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var configListener_1 = require("./configListener");
var createHttpServer_1 = require("./createHttpServer");
exports.HttpServer = function (_a, applyMiddleware) {
    var _b = _a === void 0 ? {} : _a, port = _b.port, message = _b.message, header = _b.header, _c = _b.publicDir, publicDir = _c === void 0 ? '/' : _c, Logger = _b.Logger;
    return configListener_1.configListener({
        port: port || 3000,
        message: message || 'hello httpserver!',
        publicDir: publicDir,
        header: header || {
            name: 'Access-Control-Allow-Origin',
            value: ''
        },
        Logger: Logger || {}
    }, applyMiddleware)(createHttpServer_1.createHttpServer);
};
exports.getPostValue = function (req) {
    return new Promise(function (resolve) {
        var str = '';
        req.on('data', function (data) { return (str += data); }).on('end', function () { return resolve(str); });
    });
};
