"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var http_1 = require("./http");
var saber_node_1 = require("saber-node");
exports.fileMiddleWare = function (conf) { return function (req, res) { return __awaiter(_this, void 0, void 0, function () {
    var Logger, pathname, _a, _b, value, error_1;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                Logger = conf.Logger || {};
                pathname = process.cwd().concat(conf.publicDir) + req.url;
                Logger.pathname ? console.log("pathname: [" + pathname + "]") : null;
                _c.label = 1;
            case 1:
                _c.trys.push([1, 7, , 8]);
                if (!(req.method === 'GET')) return [3 /*break*/, 3];
                _b = (_a = res).write;
                return [4 /*yield*/, saber_node_1.File.read(pathname)];
            case 2:
                _b.apply(_a, [_c.sent()]);
                res.end();
                return [3 /*break*/, 6];
            case 3:
                if (!(req.method === 'POST')) return [3 /*break*/, 6];
                return [4 /*yield*/, http_1.getPostValue(req)];
            case 4:
                value = _c.sent();
                return [4 /*yield*/, saber_node_1.File.writeFileAsync(pathname, value)];
            case 5:
                _c.sent();
                Logger.value ? console.log("value: [" + value + "]") : null;
                res.end();
                _c.label = 6;
            case 6: return [3 /*break*/, 8];
            case 7:
                error_1 = _c.sent();
                console.log(error_1.message);
                return [3 /*break*/, 8];
            case 8: return [2 /*return*/];
        }
    });
}); }; };
