# saber-httpserver

[![](https://img.shields.io/npm/v/saber-httpserver.svg?colorB=blue&style=flat)](https://www.npmjs.com/package/saber-httpserver)

> saber-httpserver

```bash
# from npm
npm install saber-httpserver

# from github
git clone https://github.com/Saber2pr/saber-httpserver.git
```

---

For example:

```ts
HttpServer({
  port: 3000,
  Logger: {
    method: true,
    api: true,
    value: true,
    pathname: true
  },
  message: 'listening...',
  publicDir: '/public'
})
```

---

## start

```bash
npm install
```

```bash
# auto compile to commonjs
npm start

# run app
npm run lau

# test
npm test

```

> Author: saber2pr

---

## develope and test

> you should write ts in /src

> you should make test in /src/test

> export your core in /src/index.ts!
